Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1881150

From https://bugzilla.redhat.com/show_bug.cgi?id=1880637#c1

We have logic that attempts to detect if foreman-maintain is installed and package locking is enabled but the output isn't being

interpreted correctly.

"""

/usr/share/foreman-installer/hooks/post/30-upgrade.rb

~

~

if !app_value(:noop) && [0, 2].include?(@kafo.exit_code) && foreman_server?

execute('foreman-rake upgrade:run')

end

~~

which appears to kick off if the kafo-puppet run had a "bad" exit code.

Looking back at that puppet run, the only error I see is

~

~

[ INFO 2020-09-18T18:21:00 verbose] Executing hooks in group pre_commit

[ERROR 2020-09-18T18:21:05 verbose] foreman-maintain packages is-locked --assumeyes failed! Check the output for error!

[ INFO 2020-09-18T18:21:05 verbose] All hooks in group pre_commit finished

~~

There are a number of warnings though.
Running that command gives:

~

~

root@tstr000047:/var/log/foreman-installer $ foreman-maintain packages is-locked --assumeyes; echo $?

Packages are not locked

1

~~

I ran it again with debug and captured this:

~

~

[ INFO 2020-09-18T19:03:39 main] Executing hooks in group pre_commit

[DEBUG 2020-09-18T19:03:39 main] Hook /usr/share/foreman-installer/katello/hooks/pre_commit/05-puppet_certs_exist.rb returned nil

[DEBUG 2020-09-18T19:03:39 main] Executing: foreman-maintain packages -h

[DEBUG 2020-09-18T19:03:41 main] Usage:

[DEBUG 2020-09-18T19:03:41 main]     foreman-maintain packages [OPTIONS] SUBCOMMAND [ARG] ...

[DEBUG 2020-09-18T19:03:41 main]
[DEBUG 2020-09-18T19:03:41 main] Parameters:

[DEBUG 2020-09-18T19:03:41 main]     SUBCOMMAND                    subcommand

[DEBUG 2020-09-18T19:03:41 main]     [ARG] ...                     subcommand arguments

[DEBUG 2020-09-18T19:03:41 main]

[DEBUG 2020-09-18T19:03:41 main] Subcommands:

[DEBUG 2020-09-18T19:03:41 main]     lock                          Prevent packages from automatic update

[DEBUG 2020-09-18T19:03:41 main]     unlock                        Enable packages for automatic update

[DEBUG 2020-09-18T19:03:41 main]     status                        Check if packages are protected against update

[DEBUG 2020-09-18T19:03:41 main]     install                       Install packages in an unlocked session

[DEBUG 2020-09-18T19:03:41 main]     update                        Update packages in an unlocked session

[DEBUG 2020-09-18T19:03:41 main]     is-locked                     Check if update of packages is allowed

[DEBUG 2020-09-18T19:03:41 main]

[DEBUG 2020-09-18T19:03:41 main] Options:

[DEBUG 2020-09-18T19:03:41 main]     -h, --help                    print help

[DEBUG 2020-09-18T19:03:41 main] foreman-maintain packages -h finished successfully!

[DEBUG 2020-09-18T19:03:41 main] Executing: foreman-maintain packages is-locked --assumeyes

[DEBUG 2020-09-18T19:03:43 main] Packages are not locked

[ERROR 2020-09-18T19:03:43 main] foreman-maintain packages is-locked --assumeyes failed! Check the output for error!

[DEBUG 2020-09-18T19:03:43 main] Hook /usr/share/foreman-installer/katello/hooks/pre_commit/09-version_locking.rb returned nil

~~

It looks like that's ultimately coming from

/usr/share/foreman-installer/hooks/boot/03-foreman-maintain-extensions.rb

~

~

def package_lock_feature?

foreman_maintain('packages -h')

end

~~

"""

Associated revisions

Revision d5e079d0 - 11/13/2020 05:03 PM - Eric Helms

Fixes #31135: Introduce execute! and execute for fatal and non-fatal commands

Introduce two separate functions that run a command. execute! will

run a command and exit if the status indicates failure. execute will

run a command and return the status of the command to let the hook

take further action. execute is intended for actions that require

information to decide what further action to take or if the action

is non-fatal.

This present previously seen errors where detecting foreman-maintain

exists on the system or foreman-maintain checks for a feature

from presenting as an error incorrectly to the user.

History

#1 - 10/23/2020 12:29 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Eric Helms

- Pull request https://github.com/theforeman/foreman-installer/pull/600 added

#2 - 11/13/2020 05:03 PM - The Foreman Bot

- Fixed in Releases 2.4.0 added

#3 - 11/13/2020 06:01 PM - Eric Helms
- Status changed from Ready For Testing to Closed

Applied in changeset installer|d5e079d0b4ccd6168a8f419bc002aac65b0607eb.

#4 - 11/16/2020 05:30 AM - Tomer Brisker

- Category set to foreman-installer script

- Fixed in Releases 2.3.0 added

- Fixed in Releases deleted (2.4.0)

#5 - 11/30/2020 05:52 PM - Ewoud Kohl van Wijngaarden

- Target version set to 2.3.0

- Triaged changed from No to Yes

Powered by TCPDF (www.tcpdf.org)

05/19/2024 4/4

https://projects.theforeman.org/projects/puppet-foreman/repository/installer/revisions/d5e079d0b4ccd6168a8f419bc002aac65b0607eb
http://www.tcpdf.org

